/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 12 "parser.ypp"

#include <cstdlib>
#include <iostream>

#include "parser/ast.hpp"
#include "proofs/dichotomy.hpp"
#include "parser/parser.h"

#define yyerror(msg) my_yyerror(yylloc, msg)

int yylex(YYSTYPE *yylval_param, YYLTYPE *yylloc_param);

#define error(msg) \
  std::cerr << "Error: " << msg << " at line " << yylloc.first_line << " column " << yylloc.first_column << '\n'
#define warning(msg) \
  std::cerr << "Warning: " << msg << " at line " << yylloc.first_line << " column " << yylloc.first_column << '\n'

int my_yyerror(YYLTYPE &yylloc, char const *errstr) {
    error(errstr);
    return EXIT_FAILURE;
}

#define failure(msg) do {\
  error(msg); \
  YYERROR; \
} while (0)

extern void register_user_rewrite(ast_real const *, ast_real const *, hint_cond_vect *);
extern void generate_graph(ast_prop const *p);
extern void test_ringularity(ast_real const *, ast_real const *, bool);
extern int test_rewriting(ast_real const *, ast_real const *, std::string &);
extern void check_approx(ast_real const *);
extern std::set< ast_real const * > free_variables;
extern bool parameter_rfma;

static ast_number const *negative_number(ast_number const *nn) {
  if (nn->base == 0) return nn;
  ast_number n = *nn;
  char &c = n.mantissa[0];
  assert(c == '+');
  c = '-';
  return normalize(n);
}

static function_class const *rounding_mode = NULL;

static ast_real const *rnd_normalize(ast_real const &real) {
  ast_real const *r = normalize(real);
  if (!rounding_mode) return r;
  return normalize(ast_real(real_op(rounding_mode, r)));
}

static unsigned long read_integer_param(ast_number const *n)
{
  return (unsigned long)(atoi(n->mantissa.c_str()) * 2) | 1;
}

#define YYINCLUDED_STDLIB_H



/* Line 189 of yacc.c  */
#line 134 "parser/parser.cpp"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FUNID = 259,
     VARID = 260,
     IN = 261,
     NUMBER = 262,
     SQRT = 263,
     FMA = 264,
     NE = 265,
     LE = 266,
     GE = 267,
     RDIV = 268,
     IMPL = 269,
     OR = 270,
     AND = 271,
     NOT = 272,
     NEG = 273
   };
#endif
/* Tokens.  */
#define IDENT 258
#define FUNID 259
#define VARID 260
#define IN 261
#define NUMBER 262
#define SQRT 263
#define FMA 264
#define NE 265
#define LE 266
#define GE 267
#define RDIV 268
#define IMPL 269
#define OR 270
#define AND 271
#define NOT 272
#define NEG 273




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 79 "parser.ypp"

  ast_number const	*number;
  ast_ident		*ident;
  ast_real const	*real;
  ast_real_vect		*reals;
  dichotomy_var		dvar;
  dvar_vect		*dvars;
  ast_prop		*prop;
  function_class const	*function;
  function_params	*params;
  unsigned long		param;
  hint_cond		*precond;
  hint_cond_vect	*preconds;



/* Line 214 of yacc.c  */
#line 223 "parser/parser.cpp"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 248 "parser/parser.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   292

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  39
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  22
/* YYNRULES -- Number of rules.  */
#define YYNRULES  73
/* YYNRULES -- Number of states.  */
#define YYNSTATES  168

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   273

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    37,     2,     2,     2,
      30,    31,    20,    18,    26,    19,     2,    21,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    35,
      32,    34,    33,    28,    36,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    25,     2,    27,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    23,    29,    24,    38,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    22
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,    11,    15,    23,    27,    31,    41,
      49,    55,    59,    63,    67,    70,    74,    76,    79,    82,
      84,    86,    88,    90,    92,    96,    97,   101,   104,   106,
     109,   110,   116,   123,   126,   129,   133,   137,   139,   141,
     143,   148,   152,   156,   160,   164,   168,   173,   182,   186,
     189,   192,   194,   198,   200,   204,   206,   210,   216,   218,
     222,   226,   230,   234,   238,   242,   244,   248,   249,   253,
     254,   261,   267,   272
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      40,     0,    -1,    41,    60,    -1,    51,    23,    42,    24,
      -1,    52,    11,    43,    -1,    52,     6,    25,    43,    26,
      43,    27,    -1,    52,     6,    28,    -1,    52,    12,    43,
      -1,    52,    13,    52,     6,    25,    43,    26,    43,    27,
      -1,    29,    52,    13,    52,    29,    11,     7,    -1,    52,
      13,    52,     6,    28,    -1,    42,    16,    42,    -1,    42,
      15,    42,    -1,    42,    14,    42,    -1,    17,    42,    -1,
      30,    42,    31,    -1,     7,    -1,    18,     7,    -1,    19,
       7,    -1,     7,    -1,    43,    -1,    45,    -1,     3,    -1,
      46,    -1,    47,    26,    46,    -1,    -1,    32,    47,    33,
      -1,     4,    48,    -1,    34,    -1,    49,    34,    -1,    -1,
      51,     3,    50,    52,    35,    -1,    51,    36,     3,    34,
      49,    35,    -1,    51,     5,    -1,    51,     4,    -1,    51,
      36,     5,    -1,    51,    36,     4,    -1,    43,    -1,     5,
      -1,     3,    -1,    49,    30,    53,    31,    -1,    52,    18,
      52,    -1,    52,    19,    52,    -1,    52,    20,    52,    -1,
      52,    21,    52,    -1,    29,    52,    29,    -1,     8,    30,
      52,    31,    -1,     9,    30,    52,    26,    52,    26,    52,
      31,    -1,    30,    52,    31,    -1,    18,    52,    -1,    19,
      52,    -1,    52,    -1,    53,    26,    52,    -1,    43,    -1,
      54,    26,    43,    -1,    52,    -1,    52,     6,    44,    -1,
      52,     6,    30,    54,    31,    -1,    55,    -1,    56,    26,
      55,    -1,    52,    10,    45,    -1,    52,    11,    45,    -1,
      52,    12,    45,    -1,    52,    32,    45,    -1,    52,    33,
      45,    -1,    57,    -1,    58,    26,    57,    -1,    -1,    23,
      58,    24,    -1,    -1,    60,    52,    14,    52,    59,    35,
      -1,    60,    53,    37,    56,    35,    -1,    60,    37,    56,
      35,    -1,    60,    52,    38,    52,    35,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   125,   125,   126,   129,   134,   136,   137,   138,   140,
     142,   143,   144,   145,   146,   147,   150,   151,   152,   155,
     162,   169,   170,   173,   174,   182,   183,   186,   199,   200,
     207,   208,   219,   225,   226,   227,   228,   231,   232,   233,
     242,   253,   254,   255,   256,   257,   258,   259,   266,   267,
     268,   271,   272,   279,   280,   283,   284,   285,   288,   289,
     296,   297,   298,   299,   300,   303,   304,   311,   312,   314,
     315,   334,   341,   347
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FUNID", "VARID", "IN",
  "NUMBER", "SQRT", "FMA", "NE", "LE", "GE", "RDIV", "IMPL", "OR", "AND",
  "NOT", "'+'", "'-'", "'*'", "'/'", "NEG", "'{'", "'}'", "'['", "','",
  "']'", "'?'", "'|'", "'('", "')'", "'<'", "'>'", "'='", "';'", "'@'",
  "'$'", "'~'", "$accept", "BLOB", "BLOB1", "PROP", "SNUMBER", "INTEGER",
  "SINTEGER", "FUNCTION_PARAM", "FUNCTION_PARAMS_AUX", "FUNCTION_PARAMS",
  "FUNCTION", "EQUAL", "PROG", "REAL", "REALS", "DPOINTS", "DVAR", "DVARS",
  "PRECOND", "PRECONDS_AUX", "PRECONDS", "HINTS", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    43,    45,
      42,    47,   273,   123,   125,    91,    44,    93,    63,   124,
      40,    41,    60,    62,    61,    59,    64,    36,   126
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    39,    40,    41,    42,    42,    42,    42,    42,    42,
      42,    42,    42,    42,    42,    42,    43,    43,    43,    44,
      45,    46,    46,    47,    47,    48,    48,    49,    50,    50,
      51,    51,    51,    51,    51,    51,    51,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    53,    53,    54,    54,    55,    55,    55,    56,    56,
      57,    57,    57,    57,    57,    58,    58,    59,    59,    60,
      60,    60,    60,    60
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     4,     3,     7,     3,     3,     9,     7,
       5,     3,     3,     3,     2,     3,     1,     2,     2,     1,
       1,     1,     1,     1,     3,     0,     3,     2,     1,     2,
       0,     5,     6,     2,     2,     3,     3,     1,     1,     1,
       4,     3,     3,     3,     3,     3,     4,     8,     3,     2,
       2,     1,     3,     1,     3,     1,     3,     5,     1,     3,
       3,     3,     3,     3,     3,     1,     3,     0,     3,     0,
       6,     5,     4,     5
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      30,     0,    69,     0,     1,     2,     0,    34,    33,     0,
       0,    39,    25,    38,    16,     0,     0,     0,     0,     0,
       0,     0,    37,     0,    51,     0,    28,     0,     0,     0,
       0,     0,     0,     0,     0,    36,    35,     0,    27,     0,
       0,    16,    49,    16,    50,     0,     0,    55,    58,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    29,
       0,    14,     0,     0,     0,     0,     0,     0,     3,     0,
       0,     0,     0,     0,    22,     0,     0,    20,    21,    23,
       0,     0,     0,    45,    48,     0,     0,    72,    51,     0,
      67,    41,    42,    43,    44,     0,    52,     0,    31,     0,
      15,    13,    12,    11,     0,     6,     4,     7,     0,     0,
      17,    18,     0,    26,    46,     0,    19,     0,    56,    59,
      40,     0,     0,    73,    71,     0,     0,     0,    32,    24,
       0,    53,     0,     0,    65,     0,    70,     0,     0,     0,
      10,     0,     0,    57,     0,     0,     0,     0,     0,    68,
       0,     0,     0,     0,     0,    54,    60,    61,    62,    63,
      64,    66,     9,     5,     0,    47,     0,     8
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    32,    22,   118,    78,    79,    80,    38,
      23,    28,     3,    33,    25,   132,    48,    49,   134,   135,
     122,     5
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -34
static const yytype_int16 yypact[] =
{
     -34,     8,   -34,     6,   -34,    56,    -3,   -34,   -34,   120,
     129,   -34,    22,   -34,   -34,    40,    88,   139,   156,   173,
     173,   173,   -34,    96,   152,    36,   -34,    -7,   173,   120,
     173,   120,   239,   205,    32,   -34,   -34,    25,   -34,   173,
     173,   -34,   -34,   -34,   -34,   223,   201,   101,   -34,    -2,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   -34,
       1,   -34,   186,    86,    77,   120,   120,   120,   -34,   263,
      -1,    -1,   173,    78,   -34,   144,   149,   -34,   -34,   -34,
      54,   209,   241,   -34,   -34,     0,   173,   -34,   266,    73,
     254,    71,    71,   -34,   -34,    37,   266,    42,   -34,   173,
     -34,   198,    87,   -34,    -1,   -34,   -34,   -34,   134,   106,
     -34,   -34,    25,   -34,   -34,   173,   -34,    -1,   -34,   -34,
     -34,   173,   127,   -34,   -34,   229,   141,   264,   -34,   -34,
     250,   -34,   104,   177,   -34,    52,   -34,   168,    -1,    -1,
     -34,   173,    -1,   -34,    -1,    -1,    -1,    -1,    -1,   -34,
     173,   176,   157,   167,   215,   -34,   -34,   -34,   -34,   -34,
     -34,   -34,   -34,   -34,    -1,   -34,   174,   -34
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -34,   -34,   -34,   -26,   -33,   -34,   135,    82,   -34,   -34,
      -4,   -34,   -34,    -5,   150,   -34,   122,   179,    81,   -34,
     -34,   -34
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      24,    12,    27,    61,    77,    63,    14,   116,     4,     6,
       7,     8,    42,    44,    45,    46,    47,    75,    76,    52,
      53,    54,    55,    60,    86,    62,    64,    59,    74,     9,
     117,    26,    14,    87,    81,    82,    98,   106,   107,   101,
     102,   103,    10,    75,    76,    88,    90,    91,    92,    93,
      94,    95,    96,    47,    37,    52,    53,    54,    55,    11,
      12,    13,    57,    14,    15,    16,    73,   108,    86,   109,
      39,   126,   123,    58,    17,    18,   149,   124,   150,    77,
     112,    47,    12,    69,   131,    19,    20,   113,    70,    71,
      72,    54,    55,    21,   125,    52,    53,    54,    55,    57,
      65,    66,    67,    67,   120,   152,   153,    85,    84,   155,
     130,    77,    77,    77,    77,    77,   133,   100,    40,    52,
      53,    54,    55,    11,    12,    13,    50,    14,    15,    16,
     142,   166,    34,    35,    36,   143,   154,    29,    17,    18,
     127,   128,    11,    12,    13,   133,    41,    15,    16,    30,
      31,   110,    52,    53,    54,    55,   111,    17,    18,    11,
      12,    13,   136,    43,    15,    16,    51,   138,    19,    20,
      52,    53,    54,    55,    17,    18,    11,    12,    13,   151,
      14,    15,    16,   162,   163,    19,    20,   144,   145,   146,
      56,    17,    18,   164,   129,    52,    53,    54,    55,    99,
      89,   167,    19,    20,    52,    53,    54,    55,   119,   147,
     148,    69,    65,    66,    67,    83,    70,    71,    72,    52,
      53,    54,    55,    52,    53,    54,    55,    52,    53,    54,
      55,   161,    84,    52,    53,    54,    55,    97,     0,     0,
     114,    52,    53,    54,    55,     0,   165,    52,    53,    54,
      55,     0,    83,    65,    66,    67,     0,     0,   137,    52,
      53,    54,    55,    68,     0,     0,     0,   115,    52,    53,
      54,    55,    52,    53,    54,    55,   141,   121,     0,   156,
     157,   158,   159,   160,    52,    53,    54,    55,   104,   139,
       0,   105,   140
};

static const yytype_int16 yycheck[] =
{
       5,     4,     6,    29,    37,    31,     7,     7,     0,     3,
       4,     5,    17,    18,    19,    20,    21,    18,    19,    18,
      19,    20,    21,    28,    26,    30,    31,    34,     3,    23,
      30,    34,     7,    35,    39,    40,    35,    70,    71,    65,
      66,    67,    36,    18,    19,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    32,    18,    19,    20,    21,     3,
       4,     5,    26,     7,     8,     9,    34,    72,    26,    73,
      30,   104,    35,    37,    18,    19,    24,    35,    26,   112,
      26,    86,     4,     6,   117,    29,    30,    33,    11,    12,
      13,    20,    21,    37,    99,    18,    19,    20,    21,    26,
      14,    15,    16,    16,    31,   138,   139,     6,    31,   142,
     115,   144,   145,   146,   147,   148,   121,    31,    30,    18,
      19,    20,    21,     3,     4,     5,    30,     7,     8,     9,
      26,   164,     3,     4,     5,    31,   141,    17,    18,    19,
       6,    35,     3,     4,     5,   150,     7,     8,     9,    29,
      30,     7,    18,    19,    20,    21,     7,    18,    19,     3,
       4,     5,    35,     7,     8,     9,    14,    26,    29,    30,
      18,    19,    20,    21,    18,    19,     3,     4,     5,    11,
       7,     8,     9,     7,    27,    29,    30,    10,    11,    12,
      38,    18,    19,    26,   112,    18,    19,    20,    21,    13,
      50,    27,    29,    30,    18,    19,    20,    21,    86,    32,
      33,     6,    14,    15,    16,    29,    11,    12,    13,    18,
      19,    20,    21,    18,    19,    20,    21,    18,    19,    20,
      21,   150,    31,    18,    19,    20,    21,    58,    -1,    -1,
      31,    18,    19,    20,    21,    -1,    31,    18,    19,    20,
      21,    -1,    29,    14,    15,    16,    -1,    -1,    29,    18,
      19,    20,    21,    24,    -1,    -1,    -1,    26,    18,    19,
      20,    21,    18,    19,    20,    21,    26,    23,    -1,   144,
     145,   146,   147,   148,    18,    19,    20,    21,    25,    25,
      -1,    28,    28
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    40,    41,    51,     0,    60,     3,     4,     5,    23,
      36,     3,     4,     5,     7,     8,     9,    18,    19,    29,
      30,    37,    43,    49,    52,    53,    34,    49,    50,    17,
      29,    30,    42,    52,     3,     4,     5,    32,    48,    30,
      30,     7,    52,     7,    52,    52,    52,    52,    55,    56,
      30,    14,    18,    19,    20,    21,    38,    26,    37,    34,
      52,    42,    52,    42,    52,    14,    15,    16,    24,     6,
      11,    12,    13,    34,     3,    18,    19,    43,    45,    46,
      47,    52,    52,    29,    31,     6,    26,    35,    52,    53,
      52,    52,    52,    52,    52,    52,    52,    56,    35,    13,
      31,    42,    42,    42,    25,    28,    43,    43,    52,    49,
       7,     7,    26,    33,    31,    26,     7,    30,    44,    55,
      31,    23,    59,    35,    35,    52,    43,     6,    35,    46,
      52,    43,    54,    52,    57,    58,    35,    29,    26,    25,
      28,    26,    26,    31,    10,    11,    12,    32,    33,    24,
      26,    11,    43,    43,    52,    43,    45,    45,    45,    45,
      45,    57,     7,    27,    26,    31,    43,    27
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1464 of yacc.c  */
#line 126 "parser.ypp"
    { generate_graph((yyvsp[(3) - (4)].prop)); }
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 130 "parser.ypp"
    {
    real_op const *p = boost::get< real_op const >((yyvsp[(1) - (3)].real));
    (yyval.prop) = new ast_prop(new ast_atom_bound((yyvsp[(1) - (3)].real), (!p || p->type != UOP_ABS) ? NULL : token_zero, (yyvsp[(3) - (3)].number)));
  }
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 135 "parser.ypp"
    { (yyval.prop) = new ast_prop(new ast_atom_bound((yyvsp[(1) - (7)].real), (yyvsp[(4) - (7)].number), (yyvsp[(6) - (7)].number))); }
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 136 "parser.ypp"
    { (yyval.prop) = new ast_prop(new ast_atom_bound((yyvsp[(1) - (3)].real), NULL, NULL)); }
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 137 "parser.ypp"
    { (yyval.prop) = new ast_prop(new ast_atom_bound((yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number), NULL)); }
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 139 "parser.ypp"
    { (yyval.prop) = new ast_prop(new ast_atom_bound((yyvsp[(1) - (9)].real), (yyvsp[(3) - (9)].real), (yyvsp[(6) - (9)].number), (yyvsp[(8) - (9)].number))); }
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 141 "parser.ypp"
    { (yyval.prop) = new ast_prop(new ast_atom_bound((yyvsp[(2) - (7)].real), (yyvsp[(4) - (7)].real), negative_number((yyvsp[(7) - (7)].number)), (yyvsp[(7) - (7)].number))); }
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 142 "parser.ypp"
    { (yyval.prop) = new ast_prop(new ast_atom_bound((yyvsp[(1) - (5)].real), (yyvsp[(3) - (5)].real), NULL, NULL)); }
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 143 "parser.ypp"
    { (yyval.prop) = new ast_prop((yyvsp[(1) - (3)].prop), PROP_AND,  (yyvsp[(3) - (3)].prop)); }
    break;

  case 12:

/* Line 1464 of yacc.c  */
#line 144 "parser.ypp"
    { (yyval.prop) = new ast_prop((yyvsp[(1) - (3)].prop), PROP_OR,   (yyvsp[(3) - (3)].prop)); }
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 145 "parser.ypp"
    { (yyval.prop) = new ast_prop((yyvsp[(1) - (3)].prop), PROP_IMPL, (yyvsp[(3) - (3)].prop)); }
    break;

  case 14:

/* Line 1464 of yacc.c  */
#line 146 "parser.ypp"
    { (yyval.prop) = new ast_prop((yyvsp[(2) - (2)].prop)); }
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 147 "parser.ypp"
    { (yyval.prop) = (yyvsp[(2) - (3)].prop); }
    break;

  case 16:

/* Line 1464 of yacc.c  */
#line 150 "parser.ypp"
    { (yyval.number) = (yyvsp[(1) - (1)].number); }
    break;

  case 17:

/* Line 1464 of yacc.c  */
#line 151 "parser.ypp"
    { (yyval.number) = (yyvsp[(2) - (2)].number); }
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 152 "parser.ypp"
    { (yyval.number) = negative_number((yyvsp[(2) - (2)].number)); }
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 156 "parser.ypp"
    {
    if ((yyvsp[(1) - (1)].number)->exponent != 0 || (yyvsp[(1) - (1)].number)->mantissa.size() >= 7) failure("the number does not look like an integer");
    (yyval.number) = (yyvsp[(1) - (1)].number);
  }
    break;

  case 20:

/* Line 1464 of yacc.c  */
#line 163 "parser.ypp"
    {
    if ((yyvsp[(1) - (1)].number)->exponent != 0 || (yyvsp[(1) - (1)].number)->mantissa.size() >= 7) failure("the number does not look like an integer");
    (yyval.number) = (yyvsp[(1) - (1)].number);
  }
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 169 "parser.ypp"
    { (yyval.param) = read_integer_param((yyvsp[(1) - (1)].number)); }
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 170 "parser.ypp"
    { (yyval.param) = reinterpret_cast< unsigned long >((yyvsp[(1) - (1)].ident)); }
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 173 "parser.ypp"
    { (yyval.params) = new function_params(1, (yyvsp[(1) - (1)].param)); }
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 175 "parser.ypp"
    {
    function_params *p = (yyvsp[(1) - (3)].params);
    p->push_back((yyvsp[(3) - (3)].param));
    (yyval.params) = p;
  }
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 182 "parser.ypp"
    { (yyval.params) = NULL; }
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 183 "parser.ypp"
    { (yyval.params) = (yyvsp[(2) - (3)].params); }
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 187 "parser.ypp"
    {
    ast_ident *r = (yyvsp[(1) - (2)].ident);
    function_class const *f;
    if (function_params *p = (yyvsp[(2) - (2)].params)) {
      f = (*r->fun)(*p);
      delete p;
    } else f = (*r->fun)(function_params());
    if (!f) failure("invalid parameters for " << r->name);
    (yyval.function) = f;
  }
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 201 "parser.ypp"
    {
    function_class const *f = (yyvsp[(1) - (2)].function);
    if (f->type != UOP_ID) failure(f->pretty_name() << " is not a rounding operator");
    rounding_mode = f;
  }
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 209 "parser.ypp"
    {
    ast_ident *v = (yyvsp[(2) - (5)].ident);
    ast_real const *r = (yyvsp[(4) - (5)].real);
    if (v->type != ID_NONE) failure("the symbol " << (yyvsp[(2) - (5)].ident)->name << " is redefined");
    v->type = ID_VAR;
    v->var = r;
    if (r->name) warning(r->name->name << " is being renamed to " << v->name);
    r->name = v;
    rounding_mode = NULL;
  }
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 220 "parser.ypp"
    {
    ast_ident *v = (yyvsp[(3) - (6)].ident);
    v->type = ID_FUN;
    v->fun = new default_function_generator((yyvsp[(5) - (6)].function));
  }
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 225 "parser.ypp"
    { failure("the symbol " << (yyvsp[(2) - (2)].ident)->name << " is redefined"); }
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 226 "parser.ypp"
    { failure("the symbol " << (yyvsp[(2) - (2)].ident)->name << " is redefined"); }
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 227 "parser.ypp"
    { failure("the symbol " << (yyvsp[(3) - (3)].ident)->name << " is redefined"); }
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 228 "parser.ypp"
    { failure("the symbol " << (yyvsp[(3) - (3)].ident)->name << " is redefined"); }
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 231 "parser.ypp"
    { (yyval.real) = normalize(ast_real((yyvsp[(1) - (1)].number))); }
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 232 "parser.ypp"
    { (yyval.real) = (yyvsp[(1) - (1)].ident)->var; }
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 234 "parser.ypp"
    {
    ast_ident *v = (yyvsp[(1) - (1)].ident);
    v->type = ID_VAR;
    ast_real *r = normalize(ast_real(v));
    free_variables.insert(r);
    v->var = r;
    (yyval.real) = r;
  }
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 243 "parser.ypp"
    {
    function_class const *f = (yyvsp[(1) - (4)].function);
    ast_real_vect *ops = (yyvsp[(3) - (4)].reals);
    if ((f->type == UOP_ID && ops->size() != 1) ||
        (f->type != UOP_ID && f->type != COP_FMA && ops->size() != 2) ||
        (f->type == COP_FMA && ops->size() != 3))
      failure("incorrect number of arguments when calling " << f->pretty_name());
    (yyval.real) = normalize(ast_real(real_op(f, *ops)));
    delete ops;
  }
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 253 "parser.ypp"
    { (yyval.real) = rnd_normalize(ast_real(real_op((yyvsp[(1) - (3)].real), BOP_ADD, (yyvsp[(3) - (3)].real)))); }
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 254 "parser.ypp"
    { (yyval.real) = rnd_normalize(ast_real(real_op((yyvsp[(1) - (3)].real), BOP_SUB, (yyvsp[(3) - (3)].real)))); }
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 255 "parser.ypp"
    { (yyval.real) = rnd_normalize(ast_real(real_op((yyvsp[(1) - (3)].real), BOP_MUL, (yyvsp[(3) - (3)].real)))); }
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 256 "parser.ypp"
    { (yyval.real) = rnd_normalize(ast_real(real_op((yyvsp[(1) - (3)].real), BOP_DIV, (yyvsp[(3) - (3)].real)))); }
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 257 "parser.ypp"
    { (yyval.real) = normalize(ast_real(real_op(UOP_ABS, (yyvsp[(2) - (3)].real)))); }
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 258 "parser.ypp"
    { (yyval.real) = rnd_normalize(ast_real(real_op(UOP_SQRT, (yyvsp[(3) - (4)].real)))); }
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 260 "parser.ypp"
    {
    if (!parameter_rfma)
      (yyval.real) = rnd_normalize(ast_real(real_op(normalize(ast_real(real_op((yyvsp[(3) - (8)].real), BOP_MUL, (yyvsp[(5) - (8)].real)))), BOP_ADD, (yyvsp[(7) - (8)].real))));
    else
      (yyval.real) = rnd_normalize(ast_real(real_op((yyvsp[(7) - (8)].real), BOP_ADD, normalize(ast_real(real_op((yyvsp[(3) - (8)].real), BOP_MUL, (yyvsp[(5) - (8)].real)))))));
  }
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 266 "parser.ypp"
    { (yyval.real) = (yyvsp[(2) - (3)].real); }
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 267 "parser.ypp"
    { (yyval.real) = (yyvsp[(2) - (2)].real); }
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 268 "parser.ypp"
    { (yyval.real) = normalize(ast_real(real_op(UOP_NEG, (yyvsp[(2) - (2)].real)))); }
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 271 "parser.ypp"
    { (yyval.reals) = new ast_real_vect(1, (yyvsp[(1) - (1)].real)); }
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 273 "parser.ypp"
    {
    (yyvsp[(1) - (3)].reals)->push_back((yyvsp[(3) - (3)].real));
    (yyval.reals) = (yyvsp[(1) - (3)].reals);
  }
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 279 "parser.ypp"
    { (yyval.param) = fill_splitter(0, (yyvsp[(1) - (1)].number)); }
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 280 "parser.ypp"
    { (yyval.param) = fill_splitter((yyvsp[(1) - (3)].param), (yyvsp[(3) - (3)].number)); }
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 283 "parser.ypp"
    { dichotomy_var v = { (yyvsp[(1) - (1)].real), 0 }; (yyval.dvar) = v; }
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 284 "parser.ypp"
    { dichotomy_var v = { (yyvsp[(1) - (3)].real), read_integer_param((yyvsp[(3) - (3)].number)) }; (yyval.dvar) = v; }
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 285 "parser.ypp"
    { dichotomy_var v = { (yyvsp[(1) - (5)].real), (yyvsp[(4) - (5)].param) }; (yyval.dvar) = v; }
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 288 "parser.ypp"
    { (yyval.dvars) = new dvar_vect(1, (yyvsp[(1) - (1)].dvar)); }
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 290 "parser.ypp"
    {
    (yyvsp[(1) - (3)].dvars)->push_back((yyvsp[(3) - (3)].dvar));
    (yyval.dvars) = (yyvsp[(1) - (3)].dvars);
  }
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 296 "parser.ypp"
    { (yyval.precond) = new hint_cond(COND_NE, (yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number)); }
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 297 "parser.ypp"
    { (yyval.precond) = new hint_cond(COND_LE, (yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number)); }
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 298 "parser.ypp"
    { (yyval.precond) = new hint_cond(COND_GE, (yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number)); }
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 299 "parser.ypp"
    { (yyval.precond) = new hint_cond(COND_LT, (yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number)); }
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 300 "parser.ypp"
    { (yyval.precond) = new hint_cond(COND_GT, (yyvsp[(1) - (3)].real), (yyvsp[(3) - (3)].number)); }
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 303 "parser.ypp"
    { (yyval.preconds) = new hint_cond_vect(1, (yyvsp[(1) - (1)].precond)); }
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 305 "parser.ypp"
    {
    (yyvsp[(1) - (3)].preconds)->push_back((yyvsp[(3) - (3)].precond));
    (yyval.preconds) = (yyvsp[(1) - (3)].preconds);
  }
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 311 "parser.ypp"
    { (yyval.preconds) = NULL; }
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 312 "parser.ypp"
    { (yyval.preconds) = (yyvsp[(2) - (3)].preconds); }
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 316 "parser.ypp"
    {
    ast_real const *r1 = (yyvsp[(2) - (6)].real), *r2 = (yyvsp[(4) - (6)].real);
    hint_cond_vect *hc = (yyvsp[(5) - (6)].preconds);
    test_ringularity(r1, r2, !hc);
    std::string info;
    int t = test_rewriting(r1, r2, info);
    if (t == 1) {
      warning("no need for the rewriting");
      std::cerr << "  if one of the following relations is present\n" << info;
    } else if (t == 2) {
      warning("no need for the rewriting");
      if (!info.empty())
        std::cerr << "  if all the following properties can be proved\n" << info;
    }
    check_approx(r1);
    register_user_rewrite(r1, r2, hc);
    delete hc;
  }
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 335 "parser.ypp"
    {
    dichotomy_hint h;
    h.dst = *(yyvsp[(2) - (5)].reals); delete (yyvsp[(2) - (5)].reals);
    h.src = *(yyvsp[(4) - (5)].dvars); delete (yyvsp[(4) - (5)].dvars);
    dichotomies.push_back(h);
  }
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 342 "parser.ypp"
    {
    dichotomy_hint h;
    h.src = *(yyvsp[(3) - (4)].dvars); delete (yyvsp[(3) - (4)].dvars);
    dichotomies.push_back(h);
  }
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 348 "parser.ypp"
    {
    if (accurates[(yyvsp[(2) - (5)].real)].insert((yyvsp[(4) - (5)].real)).second)
      approximates[(yyvsp[(4) - (5)].real)].insert((yyvsp[(2) - (5)].real));
    else
      warning("relation already known");
  }
    break;



/* Line 1464 of yacc.c  */
#line 2222 "parser/parser.cpp"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



